//+------------------------------------------------------------------+
//|                                            ay-RotationFactor.mq4 |
//|                          CopyLeft  2011, ahmad.yani@hotmail.com |
//|                                          http://eyesfx.web44.net |
//+------------------------------------------------------------------+
#property copyright "CopyLeft  2011, ahmad.yani@hotmail.com"
#property link      "http://eyesfx.web44.net"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Aqua
#property indicator_color2  Crimson
#property indicator_color3  Gray
#property indicator_color4  Yellow

extern int    NumDays      = 5;
extern string DayStartTime = "00:00";

double     BuffRFPlus[];
double     BuffRFMin [];
double     BuffRFZero[];
double     BuffRFStart[];

//int giPeriod;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_HISTOGRAM);   
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(0,BuffRFPlus);
   SetIndexBuffer(1,BuffRFMin);
   SetIndexBuffer(2,BuffRFZero);
   SetIndexArrow(2, 159);
   SetIndexBuffer(3,BuffRFStart);
   SetIndexArrow(3, 164);
   
   //giPeriod = RFTimeFrame/Period();
   
   IndicatorShortName("RFDaily");
   IndicatorDigits(0);
   SetIndexLabel(0, "RF+");
   SetIndexLabel(1, "RF-");
   SetIndexLabel(2, "RF0");
   SetIndexLabel(3, "RFStart");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if (Period() >PERIOD_H4) return(0);
   
   int    i, limit, rf;
   int    counted_bars=IndicatorCounted();

//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   int ibarRFTf, startbar;
   
   getSB(PERIOD_D1, 0, NumDays-1, 0, DayStartTime, startbar);
   
   limit = MathMin(limit, startbar+1);
   
   for(i=limit-1; i>=0; i--)
   {
      //--reset buffers
      BuffRFPlus[i] = EMPTY_VALUE; 
      BuffRFMin [i] = EMPTY_VALUE;
      BuffRFZero[i] = EMPTY_VALUE;
      BuffRFStart[i] = EMPTY_VALUE;
      
      ibarRFTf = iBarShift(NULL, PERIOD_D1, Time[i]);
     
      getSB(PERIOD_D1, 0, ibarRFTf, i, DayStartTime, startbar);
     
      rf = getRF(startbar, i);
      
      if (rf>0)  BuffRFPlus[i] = rf;
      if (rf<0)  BuffRFMin [i] = rf;  
      if (rf==0) BuffRFZero[i] = rf;  
      
      if (i==startbar) BuffRFStart[i] = 0;
   }   
   
   return(0);
  }
  
int getRF(int sb, int eb)
{
   int i, rf;
   for (i=sb; i>=eb; i--)
   {
      if ( High[i] > High[i+1] ) rf++;
      if ( Low[i]  > Low[i+1]  ) rf++;   
      if ( High[i] < High[i+1] ) rf--;
      if ( Low[i]  < Low[i+1]  ) rf--;
   }
   
   return(rf);
}

void getSB(int htf, int ltf, int ibarhtf, int ibarltf, string starttime, int &startbar)
{

   int oneday = PERIOD_D1*60 ;
   datetime dtstart;                                           
   datetime dthtf = iTime( NULL, htf, ibarhtf );   
   datetime dtltf = iTime( NULL, ltf, ibarltf);       

   dtstart  = StrToTime(TimeToStr(dthtf,TIME_DATE) + " " + starttime);   
   if (dtstart > dtltf) dtstart -= oneday;                                   
   startbar  = iBarShift ( NULL, ltf, dtstart ); 

   if (iTime(NULL, ltf, startbar) < dtstart) startbar--;

}  
//+------------------------------------------------------------------+